
#include "Ble Test1 Defs.h"
#include "aci_cmds.h"
#include "aci_evts.h"
#include "acilib_prototypes.h"
#include "Android.h"

extern short readBuff[32];
char txBuff[32];

static void SetIntValueToBuffer(unsigned int Value){
  //Divide to 4x4bit value
  txBuff[0] = (char)((Value >> 12)& 0xF); //HHHsb
  txBuff[1] = (char)((Value >> 8)& 0xF);  //HHsb
  txBuff[2] = (char)((Value >> 4) & 0xF); //Hsb
  txBuff[3] = (char)(Value & 0xF);        //Lsb
}


//Message format:
//readBuff[0] - Message Lenght
//readBuff[1] - Event
//readBuff[2] - Service Pipe No.
//readBuff[3...20] - Received data
void OnDataReceived() {

   unsigned int tmp1,tmp2,tmp3;


   if (readBuff[ANDR_CMD_POS] == CMD_GET) {  //read buffer[4] is cmd byte
         //Output
         tmp1 = readBuff[ANDR_CMD_POS + 1];
         GPIOD_ODR = tmp1 & 0xF;
         //Input
         tmp2 = (char)GPIOD_IDR & 0xF0;
         txBuff[0] = (char)(tmp2 >> 4);
         txBuff[1] = (char)(tmp2 & 0xF);
         //Adc
         tmp3 = ADC1_Get_Sample(5);
         delay_ms(20);
         txBuff[2] = (char)((tmp3 >> 12)& 0xF); //HHHsb
         txBuff[3] = (char)((tmp3 >> 8)& 0xF);  //HHsb
         txBuff[4] = (char)((tmp3 >> 4) & 0xF); //Hsb
         txBuff[5] = (char)(tmp3 & 0xF);        //Lsb
         
         BlueLE_SendData(&txBuff,6,TxPipe);
   }
}