
#include "Ble Test1 Defs.h"
#include "aci_cmds.h"
#include "aci_evts.h"
#include "acilib_prototypes.h"
#include "Android.h"



extern sfr sbit BlueLE_CONN;
extern sfr sbit BlueLE_BONDED;
extern char writeBuff[32];
extern short readBuff[32];
char CONN_STATE = 0;
char NEW_EVT;


void main() {


   GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_1 | _GPIO_PINMASK_2 | _GPIO_PINMASK_3) ;
   GPIO_Digital_Input(&GPIOD_BASE, _GPIO_PINMASK_4 | _GPIO_PINMASK_5 | _GPIO_PINMASK_6 | _GPIO_PINMASK_7);
   
   //Adc
   ADC_Set_Input_Channel(_ADC_CHANNEL_5); //ADC on PA5
   Adc1_Init();

   

   Delay_ms(200);
   Init_MCU();
   BlueLE_Setup();
   Delay_ms(100);

   while(1) {
      BlueLE_Bond(0xB4, 0x20);
      BlueLE_Read();
      BlueLE_BONDED = 1;
      BlueLE_WaitForEvent(ACI_EVT_CONNECTED);
      BlueLE_WaitForEvent(ACI_EVT_PIPE_STATUS);
      BlueLE_Read();
      CONN_STATE = 1;
      BlueLE_CONN = 1;
      NEW_EVT = 0;
      delay_ms(100);
      while(CONN_STATE){
         NEW_EVT = BlueLE_EventCode();
         switch(NEW_EVT) {
            case ACI_EVT_DATA_RECEIVED: //Data received notification event
              OnDataReceived();
              break;
            case ACI_EVT_HW_ERROR:
              delay_ms(20);
              break;
            case ACI_EVT_DISCONNECTED:  //Disconnected from peer device
              CONN_STATE = 0;
         }
         UART_Write(NEW_EVT);
         UART_Write(0x0D);
      }
      BlueLe_Disconnect();
      BlueLE_CONN = 0;
      BlueLE_BONDED = 0;
   }
}